$TITLE:'GREENWICH HOUR ANGLE/MOD JULIAN DAY'
       SUBROUTINE GHA(DAY,TIME,YEAR,RAGM) 
C 
C    INPUT:
C              DAY       R*8       DAY OF YEAR
C              TIME      R*8       SECONDS OF DAY
C              YEAR      R*8       YEAR - 4 DIGITS
C    OUTPUT:
C              RAGM      R*8       GHA = RIGHT ASCENTION OF GREENWICH MERID.
C
C
$INCLUDE:'WRDSIZ.INC'
C 
       DATA SPD    / 86400.0D0/
       DATA DPJC   / 36525.0D0/
       DATA MJDZ   / 15019   /
       DATA TZ     / 23925.836D0/
       DATA  DT2   / 8640184.542D0/
       DATA  DDT2  / 0.0929D0 / 
       DATA  WE    / 1.002737909265D0/
       DATA  WED   / 0.589D-10/ 
       DATA  JDAY  / -1 /
       DATA  JYR   / -1 / 
C 
C LAST MODIFIED:  
C         12-20-99   JAN 1 1900 CORRECTED MJD, MADE VALUED R*8 IN DATA
C
       IDAY = DAY 
       IYEAR = YEAR 
C
       JDAY = IDAY
       JYR = IYEAR
       DMJD = 0.5D0 + MJD(IYEAR,IDAY) - MJDZ
       TU = DMJD/DPJC 
       A1 = (TZ + DT2 * TU + DDT2 * TU * TU) / SPD
       ATEMP = (WE + WED * TU) / SPD
C
10     CONTINUE 
C
       A2 = ATEMP * TIME
       IA = A1 + A2 
       A = A1 + A2 - IA 
       RAGM = 360.0D0 * A 
       RETURN 
       END
$PAGE
      FUNCTION MJD (IYR,IDAY) 
C
C       GIVEN INTEGER YEAR AND DAY OF YEAR
C       RETURN THE MODIFIED JULIAN DAY
C
$INCLUDE:'WRDSIZ.INC'
C 
C         ==========  JRC 12-20-99  USE MAIN ROUTINE ====
C
      CALL YD2MJD ( IYR, IDAY, MJDV)
C
      MJD = MJDV
C
      END 
