      SUBROUTINE MDY2JD (MONTH, IDAY, JYEAR, RJD )
C
C
C     COMPUTE THE ABSOLUTE JULIAN DATE
C
C    --------------------------------------------------------------
C         ANSWERS ALWAYS END IN 0.5 AS 00UT IS 0.5 INTO A J.D.
C    --------------------------------------------------------------
C
C
C    INPUT:    
C              MONTH     I*4
C              IDAY      I*4    DAY OF MONTH
C              IYEAR     I*4    YEAR, 2 OR 4 DIGIT
C
C  OUPUT
C
C     RJD    R*8    JULIAN DATE (ABSOLUTE ) AT 00UT ON DAY GIVEN
C
C
C
C     LOGIC / BRUCE R. BARKSTROM AS FROM CBASIC PROGRAM IN JULY 81 BYTE/
C         MOVED TO PC  3/95  JRC
C         MADE DAY OF MONTH, FIXED
C     CONVERTED TO FORTRAN / DRB / 8-25-81
C     LAST ALTERED /
C         02/16/87   LJB   FORTRAN 4 TO FORTRAN 5
C
C
$INCLUDE:'WRDSIZ.INC'
C
C     FIRST DAY OF MONTHS
C
      DIMENSION FDOM(12)
C
      DATA FDOM /0.0, 31.0, 59.0, 90.0, 120.0, 151.0, 181.0, 212.0,
     $     243.0, 273.0, 304.0, 334.0/
C
C         ---------------------------------------------------
C
      IYEAR = JYEAR
      IF ( IYEAR.LT.50 ) IYEAR = IYEAR + 2000
      IF ( IYEAR.GT.50 .AND. IYEAR.LT.100 ) IYEAR = IYEAR + 1900
C
C     YEARS SINCE ZERO
C
      IYSZ = IYEAR + 4712
C
C     NO. OF LEAP YEARS
C
      NLPY = (IYSZ - 1) / 4
C
      TOTDAY = 365.0D0 * IYSZ + NLPY
C
C         HANDLE THE POST-GEGORIAN CALENDAR ITEMS
C
      IF (IYEAR.GE.1583) THEN
C
           TOTDAY = TOTDAY - 10.0
C
C     NO. OF CENTURY YEARS SINCE 1583, LEAPS SINCE 1583
C
          NCYS83 = (IYEAR - 1501) / 100
          NCLY83 = (IYEAR - 1201) / 400
C
          TOTDAY = TOTDAY - NCYS83 + NCLY83
C
      ENDIF
C
C
C     DEAL WITH MONTH AND DAY
C
      TOTDAY = TOTDAY + FDOM(MONTH) + IDAY
C
C     LEAP YEAR THIS YEAR
C
      IF ((MOD(IYEAR,4).EQ.0).AND.(MONTH.GE.3)) TOTDAY = TOTDAY + 1.0
C
      IF ((IYEAR.EQ.1582).AND.(((MONTH.EQ.10).AND.(IDAY.GE.15))
     $   .OR.(MONTH.GE.11))) TOTDAY = TOTDAY - 10.0
C
900   CONTINUE
C
      RJD = TOTDAY - 0.5D0
      RETURN
      END
$PAGE
      SUBROUTINE YD2JD ( JYEAR, IDOY, RJD )
C
C
C     COMPUTE THE ABSOLUTE JULIAN DATE
C
C
C    --------------------------------------------------------------
C         ANSWERS ALWAYS END IN 0.5 AS 00UT IS 0.5 INTO A J.D.
C    --------------------------------------------------------------
C
C
C    INPUT:    
C              IDOY     I*4     DAY OF YEAR
C              IYEAR     I*4    YEAR, 2 OR 4 DIGIT
C
C         
C
C  OUPUT
C
C     RJD    R*8     JULIAN DATE (ABSOLUTE)
C
C
C
C
C     LOGIC / BRUCE R. BARKSTROM AS FROM CBASIC PROGRAM IN JULY 81 BYTE/
C         MOVED TO PC  3/95  JRC
C         MADE DAY OF MONTH, FIXED
C     CONVERTED TO FORTRAN / DRB / 8-25-81
C     LAST ALTERED /
C         02/16/87   LJB   FORTRAN 4 TO FORTRAN 5
C
C
$INCLUDE:'WRDSIZ.INC'
C
C
C         ---------------------------------------------------
C
      IYEAR = JYEAR
      IF ( IYEAR.LT.50 ) IYEAR = IYEAR + 2000
      IF ( IYEAR.GT.50 .AND. IYEAR.LT.100 ) IYEAR = IYEAR + 1900
C
C     YEARS SINCE ZERO
C
      IYSZ = IYEAR + 4712
C
C     NO. OF LEAP YEARS
C
      NLPY = (IYSZ - 1) / 4
C
      TOTDAY = 365.0D0 * IYSZ + NLPY
C
C         HANDLE THE POST-GEGORIAN CALENDAR ITEMS
C
      IF (IYEAR.GE.1583) THEN
C
           TOTDAY = TOTDAY - 10.0
C
C     NO. OF CENTURY YEARS SINCE 1583, LEAPS SINCE 1583
C
          NCYS83 = (IYEAR - 1501) / 100
          NCLY83 = (IYEAR - 1201) / 400
C
          TOTDAY = TOTDAY - NCYS83 + NCLY83
C
      ENDIF
C
C
C          ADD DAY OF YEAR
C
      TOTDAY = TOTDAY + IDOY
C
C
      IF ( IYEAR.EQ.1582 ) THEN
             IF (IDOY.GE.288 ) TOTDAY = TOTDAY - 10
      ENDIF
C
900   CONTINUE
C
      RJD = TOTDAY - 0.5
      RETURN
      END
