$TITLE:'RADIUS POSITION'
$SUBTITLE:'RADIUS POSITION'
      SUBROUTINE RADPOS ( X1, X2, R, X )
C
C          FIND POSITION ALONG PATH STATION TO SAT.
C          AT GIVEN RADIUS
C
C       INPUT
C              X1(3)        STATION POSITION
C              X2(3)        SATELLITE POSITION
C              R            NEEDED RADIUS VECTOR MAGITUDE
C
C       OUTPUT 
C              X(3)         VECTOR ALONG X1 TO X2 WITH
C                           LENGTH R
C       
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION X1(3), X2(3), X(3)
C
      DIMENSION  V(3)
C
C
C
C          FROM CYBER ROUTINE INTRCPT
C
C --------------------------------------------------------------------
C
C
C            DEFAULT ANSWER IF NONE
C      
      X(3)    =   0.0D0
      X(2)    =   X(3)
      X(1)    =   X(2)
C
C         BASE VECTOR LENGTH
C
      Z1      =   X1(1)
      Z2      =   X1(2)
      Z3      =   X1(3)
C
      RS1     =   (Z1*Z1 + Z2*Z2 + Z3*Z3)
C
C           DIFFERENCE VECTOR
C           LENGHT AND DIRECTION
C
      V(1)    =   X2(1) - Z1
      V(2)    =   X2(2) - Z2
      V(3)    =   X2(3) - Z3
C
      VMAG    =   SQRT( V(1)*V(1) + V(2)*V(2) + V(3)*V(3) )
C
      V(1)    =   V(1)/VMAG
      V(2)    =   V(2)/VMAG
      V(3)    =   V(3)/VMAG
C
C           COMPONENT OF BASE IN DIRECTION OF DIFFERENCE
C
      CR1     =  -( V(1)*Z1 + V(2)*Z2 + V(3)*Z3 )
C
C       NOW SOLVE QUADRATIC FOR FRACTIN TO ADD
C
      S       =   1.0D0 -  CR1*CR1/RS1
      RAD     =   R*R - RS1*S
C
      IF ( RAD .LT. 0.0D0 ) RETURN
C
      Y     =     SQRT(RAD) + CR1
C
      X(1)  =     Z1 + Y*V(1)
      X(2)  =     Z2 + Y*V(2)
      X(3)  =     Z3 + Y*V(3)
C
      RETURN
C
      END
$PAGE
$SUBTITLE:'EL,AZ,SR TO POINT'
       SUBROUTINE  AZELRX ( XZ, AZ, EL, SLANTR,  XOUT )
C
C         AZ EL SLANT FROM POINT TO NEW POINT
C
C    INPUT:
C              XZ(3)    R*8   BASE LOCATION ( KM )
C              AZ       R*8   AZIMUTH  DEG
C              EL       R*8   ELEVATIN DEG
C              SLANTR   R*8   SLANT RANGE KM
C
C    OUTPUT:
C              XOUT(3)  R*8   OUTPUT VECTOR (KM )
C
C         9-29-93   GENERATED JRC
C
C    MODHIST:
C
C
$INCLUDE:'WRDSIZ.INC'
C
$INCLUDE:'CONSET.INC'
C
C
      DIMENSION   XZ(3) ,  XOUT ( 3 )
      DIMENSION   EE(3), EN(3), EU(3)
      DIMENSION   XSUM(3)
C
C                   ---------------------------------
C
      IF ( PI .EQ. 0.0D0 ) CALL CONSET
C
C
      CALL  XYZENU ( XZ, EE,EN,EU )
C
      AZR  =  DTR * AZ
      ELR  =  DTR * EL
C
      CA   =  DCOS ( AZR )
      SA   =  DSIN ( AZR )
C
      CE   =  DCOS ( ELR )
      SE   =  DSIN ( ELR )
C
      DU    =  SLANTR * SE
      DE    =  SLANTR * CE * SA
      DN    =  SLANTR * CE * CA
C
C
      CALL  ADDVEC ( XZ,  EE, DE, XSUM )
      CALL  ADDVEC ( XSUM,EN, DN, XSUM )
      CALL  ADDVEC ( XSUM,EU, DU, XOUT )
C
C
      RETURN
      END
