$TITLE:'SPACE VEHICLE GEOMETRY ROUTINES'
      FUNCTION SLANT(X,Y) 
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION X(1), Y(1), Z(3)      
C
C      FINDS SLANT RANGE BETWEEN TWO VECTORS. 
C 
      Z(1) = Y(1) - X(1)
      Z(2) = Y(2) - X(2)
      Z(3) = Y(3) - X(3)
      SLANT = DSQRT(Z(1)*Z(1) + Z(2)*Z(2) + Z(3)*Z(3)) 
      RETURN
      END 
$PAGE
      FUNCTION ELVANS(X,Y)
C
$INCLUDE:'WRDSIZ.INC'
C
C     FINDS THE ELEVATION ANGLE OF THE SECOND POINT WITH RESPECT TO 
C     THE FIRST POINT.
C
C         ======SPHERICAL EARTH VERSION  ======
C 
      DIMENSION X(1), Y(1), Z(3)
C
$INCLUDE:'CONSET.INC'
C
C         --------------------------------
C
      IF ( PI.EQ.0.0D0 ) CALL CONSET
C
C              ----------
C
      CALL ADD VEC (Y, X, -1.0D0 , Z)
C
      R3     = COS VECS (Z,X) 
      ELVANS = 90.0D0 - DACOS(R3) * RTD 
      RETURN
      END 
$PAGE
      SUBROUTINE SATAZS (STAT,SAT,AZ)
C
C          SATELLITE AZIMUTH
C
C      ========SPHERICAL EARTH VERSION========
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION STAT(3),SAT(3)
C
C
$INCLUDE:'CONSET.INC'
C
C         --------------------------------
C
      IF ( PI.EQ.0.0D0 ) CALL CONSET
C
C              ----------
C 
C 
      XY    = STAT(1)*STAT(1) + STAT(2)*STAT(2) 
      XYZ   = XY + STAT(3)*STAT(3)
      XY    = DSQRT(XY) 
      XYZ   = DSQRT(XYZ) 
C 
      COSL = STAT(1)/XY 
      SINL = STAT(2)/XY 
      SINT = STAT(3)/XYZ
C 
      XN1 = -SINT * COSL
      XN2 = -SINT * SINL
      XN3 = XY/XYZ
C 
      XE1 = -SINL 
      XE2 = COSL
C 
      Z1 = SAT(1) - STAT(1) 
      Z2 = SAT(2) - STAT(2) 
      Z3 = SAT(3) - STAT(3) 
C 
      P1 = XN1*Z1 + XN2*Z2 + XN3*Z3 
      P2 = XE1*Z1 + XE2*Z2
C 
      TEST = DABS(P1) + DABS(P2)
C 
C 
      IF(TEST.LE.1D-16) GOTO 30 
C 
C 
      BETA  = DATAN2(P1,P2) * RTD
      ALPHA = 90.0D0 - BETA 
C
      IF (ALPHA) 10,20,20 
  10  ALPHA = ALPHA + 360.0D0 
  20  AZ = ALPHA
      RETURN
C 
   30 CONTINUE
      AZ = 0.0D0
      RETURN
      END 
$PAGE
      FUNCTION SLANTSQ (X1,X2)
C
C     FUNCTION RETURNS THE SQUARE OF DIFFERENCE VECTOR
C
$INCLUDE:'WRDSIZ.INC'
C 
      DIMENSION X1(3),X2(3),XD(3) 
C
      CALL ADD VEC (X1,X2, -1.0D0, XD)
C
      S       = XD(1)*XD(1)+XD(2)*XD(2)+XD(3)*XD(3) 
      SLANTSQ = S 
C
      RETURN
      END 
$PAGE
      SUBROUTINE XYZ T SPH (X1, R, THETA, PHI)
C
$INCLUDE:'WRDSIZ.INC'
C
C 
C      THIS CONVERTS RECTANGULAR TO SPHERICAL COORDINATES.
C      (BUT REALLY TO RANGE,LATITUDE,AND LONGITUDE) 
C 
      DIMENSION X1(1) 
C
C
$INCLUDE:'CONSET.INC'
C
C         --------------------------------
C
      IF ( PI.EQ.0.0D0 ) CALL CONSET
C
C              ----------
C 
      X = X1(1) 
      Y = X1(2) 
      Z = X1(3) 
C
      R     = DSQRT (X*X + Y*Y + Z*Z)
      THETA = DASIN (Z/R) * RTD
C 
      IF( (DABS(X) + DABS(Y)) .NE. 0.0D0) GO TO 10

      PHI=0.
      RETURN
C 
   10 CONTINUE
C
      PHI  = DATAN2 (Y,X) * RTD 
      IF (PHI .LT. 0.0D0 ) PHI = PHI + 360.0 D0
C
      RETURN
      END
$PAGE
      SUBROUTINE SPH T XYZ (X1, R, THETA, PHI)
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION X1(1) 
C
C
$INCLUDE:'CONSET.INC'
C
C         --------------------------------
C
      IF ( PI.EQ.0.0D0 ) CALL CONSET
C
C              ----------
C 
C 
C      THIS CONVERTS SPHERICAL TO RECTANGULAR COORDINATES.
C 
      S1    = DSIN (DTR*THETA)
      S2    = DSIN (DTR*PHI)
      C1    = DCOS(DTR*THETA) 
      C2    = DCOS(DTR*PHI) 
      X1(1) = R*C1*C2 
      X1(2) = R*C1*S2 
      X1(3) = R * S1
      RETURN
      END 
$PAGE
      SUBROUTINE LT LN XYZ(R,THETA,PHI,X,Y,Z,ITYPE)
C
$INCLUDE:'WRDSIZ.INC'
C
C     R/LAT/LON TO FROM XYZ
C     ITYPE FOR DIRECTION
C         1 =  R/LAT/LON TO XYZ
C       OTHER   INVERSE
C     
C      ANGLES IN DEG
C
C
C
$INCLUDE:'CONSET.INC'
C
C         --------------------------------
C
      IF ( PI.EQ.0.0D0 ) CALL CONSET
C
C              ----------
C 
C
      IF( ITYPE .NE. 1 ) GO TO 100 
C
      X     = R * DCOS( DTR*THETA ) * DCOS( DTR*PHI ) 
      Y     = R * DCOS( DTR*THETA ) * DSIN( DTR*PHI ) 
      Z     = R * DSIN( DTR*THETA )
      GO TO 200 
C
  100 CONTINUE
C
      R    = DSQRT( X*X + Y*Y + Z*Z ) 
      A    = DATAN( Y/X ) / DTR 
C
      IF( X .LT. 0.D0 ) A = A + 180.D0
      IF( A .LT. 0.D0 ) A = A + 360.D0
C
      PHI   = A 
      THETA = DASIN( Z / R ) / DTR 
C
  200 CONTINUE
C
      RETURN
      END 
$PAGE
$SUBTITLE:'ORBIT PLANE UNIT VECTORS'
      SUBROUTINE PAX ORB ( X, V, ER, EL, EX )
C
C    INPUTS
C         X  = 3 VECTOR OF POSITION 
C         V  = 3 VECTOR OF VELOCITY
C             ... THESE ARE ROTATING COORDIANTE VALUES ...
C     OUTPUTS
C         ER  = 3 UNIT VECTOR OF RADIAL COMPONENT 
C         EL  = 3 UNIT VECTOR OF LONG TRACK COMPONENT
C         EX  = 3 UNIT VECTOR OF CROSS TRACK COMPONENT
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION X(3),V(3),ER(3),EL(3),EX(3)
      DIMENSION TV(3), VI(3)
C
      CALL EFV2I ( X, V, VI )
C
      CALL NORMV (  X,  ER )
      CALL CROSS ( ER,  VI,  TV )
      CALL NORMV ( TV,  EX )
      CALL CROSS ( EX,  ER,  TV )
      CALL NORMV ( TV,  EL )
C
      RETURN
      END
$PAGE
$SUBTITLE:'EARTH FIXED TO INERTIAL VEL'
      SUBROUTINE EFV2I ( XEF, VEF, VINERT )
C
C     EARTH FIXED VELOCITY TO INERTIAL
C     INTERNAL MATH SO CAN USE SAME VEL AS INPUT AND
C     OUTPUT IF WANT
C
C     INPUTS
C         XEF   3 VECTOR OF POITION EARTH FIXED FRAME
C         VEF   3 VECTOR OF TIME DERIV OF XEF ( IE ROT VEL )
C     OUTPUT
C        VINERT 3 VECTOR INERTIAL = VEF +  WE X XEF
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION XEF(3), VEF(3), VINERT(3)
C
C
C
$INCLUDE:'CONSET.INC'
C
C       DEFAULT ROT RATE EARTH = WGS84 / GPS 
C
      DATA WE84 / 7.29211 51467 D-5 /
      DATA IINT / 0 /
C
C
      IF ( IINT .NE. 0 ) GOTO 100
         DWE = DABS ( WE84 - WE )
         IF ( DWE .GT. 1.0D-10 )  WE = WE84
         IINT  = 1
C
100   CONTINUE
C
C
      DVX  =  -WE * XEF(2)
      DVY  =   WE * XEF(1)
C
      VINERT(1)  = VEF(1) + DVX
      VINERT(2)  = VEF(2) + DVY
      VINERT(3)  = VEF(3)
C
      RETURN
      END
$PAGE
$SUBTITLE:'EARTH FIXED TO INERTIAL VEL AND ACC'
      SUBROUTINE EFVA2I ( XEF, VEF, AEF, VINERT, AINERT )
C
C     EARTH FIXED VELOCITY TO INERTIAL
C     INTERNAL MATH SO CAN USE SAME VEL AS INPUT AND
C     OUTPUT IF WANT
C
C     INPUTS
C         XEF   3 VECTOR OF POITION EARTH FIXED FRAME
C         VEF   3 VECTOR OF TIME DERIV OF XEF ( IE ROT VEL )
C         AEF   3 VECTOR OF TIME DERIV OF VEF
C     OUTPUT
C        VINERT 3 VECTOR INERTIAL VEL   = VEF +  WE X XEF
C        AINERT 3 VECTOR INERTIAL ACCEL
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION XEF(3), VEF(3), VINERT(3), AEF(3), AINERT(3)
C
C
C
$INCLUDE:'CONSET.INC'
C
C       DEFAULT ROT RATE EARTH = WGS84 / GPS 
C
      DATA WE84 / 7.29211 51467 D-5 /
      DATA IINT / 0 /
C
C
      IF ( IINT .NE. 0 ) GOTO 100
         DWE = DABS ( WE84 - WE )
         IF ( DWE .GT. 1.0D-10 )  WE = WE84
         IINT  = 1
C
         WES  = WE * WE 
C
100   CONTINUE
C
C
      DVX  =  -WE * XEF(2)
      DVY  =   WE * XEF(1)
C
      DAX1 =  -2.0D0 * WE * VEF(2)
      DAY1 =   2.0D0 * WE * VEF(1)
C
      DAX2 =  - WES * XEF(1)
      DAY2 =  - WES * XEF(2)
C
      VINERT(1)  = VEF(1) + DVX
      VINERT(2)  = VEF(2) + DVY
      VINERT(3)  = VEF(3)
C
      AINERT(1)  = AEF(1) + DAX1 + DAX2
      AINERT(2)  = AEF(2) + DAY1 + DAY2
      AINERT(3)  = AEF(3)
C
      RETURN
      END
